﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace Violet.ComponentModel
{
    public class SimpleBackgroundWorker : IDisposable
    {
        public delegate void WorkCompletedHandler();
        public event WorkCompletedHandler WorkCompletedEvent;

        public delegate void WorkProcessHandler();
        public event WorkProcessHandler WorkProcessEvent;

        BackgroundWorker mWorker;

        public SimpleBackgroundWorker()
        {
            mWorker = new BackgroundWorker();
            mWorker.DoWork += new System.ComponentModel.DoWorkEventHandler(worker_DoWork);
            //mWorker.ProgressChanged += new System.ComponentModel.ProgressChangedEventHandler(worker_ProgressChanged);
            mWorker.WorkerReportsProgress = true;
            mWorker.WorkerSupportsCancellation = true;
            mWorker.RunWorkerCompleted += new System.ComponentModel.RunWorkerCompletedEventHandler(worker_RunWorkerCompleted);
        }

        public void start()
        {
            mWorker.RunWorkerAsync();
        }

        public void Dispose()
        {
            mWorker.Dispose();
        }

        protected virtual void process() { }

        protected virtual void complete() { }

        private void worker_DoWork(object sender, System.ComponentModel.DoWorkEventArgs e)
        {
            if (WorkProcessEvent != null)
            {
                WorkProcessEvent();
            }
            process();
        }

        private void worker_RunWorkerCompleted(object sender, System.ComponentModel.RunWorkerCompletedEventArgs e)
        {
            if (WorkCompletedEvent != null)
            {
                WorkCompletedEvent();
            }
            complete();
        }
    }
}
